using Gtk;
using Granite;

namespace Focus {

    public class Focus : Granite.Application {

        private FocusWindow window = null;

        construct {

            program_name = "Focus";
            exec_name = "focus";

            app_years = "2012";
            application_id = "net.launchpad.focus-app";
            app_icon = "appointment-new";
            app_launcher = "focus.desktop";

            main_url = "https://code.launchpad.net/focus-app";
            bug_url = "https://bugs.launchpad.net/focus-app";
            help_url = "https://code.launchpad.net/focus-app";
            translate_url = "https://translations.launchpad.net/focus-app";
        
            about_authors = {"Alexander Wilms <f.aleander.wilms+spam@gmail.com>, Victor Eduardo <>, Dane Henson <dane.henson@gmail.com>"};
            //about_documenters = {" "};
            //about_artists = {" "};
            //about_comments = "Development release, not all features implemented";
            about_translators = "";
            about_license_type = Gtk.License.GPL_3_0;
        }

        protected override void activate () {
                        
            if (window != null) {
                window.present (); // present window if app is already open
                return;
            }
            
            window = new FocusWindow ();
            window.set_application (this);
            window.show_all ();
        }

    	public static int main (string[] args) {
	        Gtk.init(ref args);
	        var app = new Focus ();
	        
	        if (args[1] == "-s") {
		        return 0;
	        }
	        
	        return app.run (args);
        }
    }
}
