using Gtk;

namespace Focus {
    
    int total;
    bool running;
    Label label;
    string status;
    Notifier Timesup;

    public class FocusWindow : Granite.Widgets.LightWindow {
    
        public static Granite.Application app { get; private set; }
public FocusWindow () {
        
            this.app = app;
            this.title = "Focus";      // Set the window title
            this.resizable = false;     // Window is not resizable
            this.set_keep_above (true); // Window stays on top of other windows
    
    this.window_position = WindowPosition.CENTER;
    this.delete_event.connect(minimize_on_close);
 
	Grid grid = new Grid();
    grid.margin = 12;
    grid.expand = true;
	Grid buttonbox = new Grid();
	
	var display = "00:00";
	label = new Label("<span font-family=\"Open Sans\" font-weight=\"bold\" size=\"50000\">" + display + "</span>");
    label.set_use_markup (true);
	grid.attach(label, 0, 0, 1, 1);
	grid.attach(buttonbox, 0, 1, 1, 1);
	
	running = false;
	
	var focus = new Button.with_label("Focus");
	buttonbox.attach(focus, 0, 0, 1, 1);
	focus.clicked.connect (() => {
	total = 25 * 60;
	if(!running) {
    running = true;
	Timeout.add (1000, countdown);
	}
    status = "p";
	});
	
	var short_break = new Button.with_label("Short Break");
	buttonbox.attach(short_break, 1, 0, 1, 1);
	short_break.clicked.connect (() => {
	total = 5 * 60;
	if(!running) {
    running = true;
	Timeout.add (1000, countdown);
	}
    status = "s";
	});
	
	var long_break = new Button.with_label("Long Break");
	buttonbox.attach(long_break, 2, 0, 1, 1);
	long_break.clicked.connect (() => {
	total = 15 * 60;
	if(!running) {
    running = true;
	Timeout.add (1000, countdown);
	}
    status = "l";
	});
	
	this.add(grid);
    this.show_all();
}

bool countdown() {
	if(total == -1) {
        running = false;
        Timesup = new Notifier ();

        if(status == "p") {
            Timesup.notify ("Time's up!", "Time to relax", "dialog-information");
        } else {
            Timesup.notify ("Time's up!", "Back to work", "dialog-information");
        } 
	    return false;
    }
	int min = total / 60;
	int sec = total % 60;
	string minstring = min.to_string();
	string secstring = sec.to_string();
    // Two digits for the minute display?
	if(min < 10) {
		minstring = "0" + minstring;
	}
	if(sec < 10) {
		secstring = "0" + secstring;
	}
	string timer = minstring + ":" + secstring;
	total--;
	label.set_markup("<span font-family=\"Open Sans\" font-weight=\"bold\" size=\"50000\">" + timer + "</span>");
	return true;
}

bool minimize_on_close () {
    if (running) {
        this.iconify();
        return true; // prevent window destruction
    }
    return false;
    
}
}

}
