using Canberra;

public class Notifier {
    public Notifier () { print("Created a Notifier \n"); }

    private Notify.Notification notification;

    public void beep () {
	Context hello;
	Context.create(out hello);
	hello.play (0,
		PROP_EVENT_ID, "alarm-clock-elapsed",
		PROP_EVENT_DESCRIPTION, "hello world");
	Thread.usleep (1000000); // Play alarm for 1 sec
	}

    public void notify (string primary_text, string secondary_text, string icon_name) {
        if (!Notify.is_initted () && !Notify.init ("focus")) {
            warning ("Could not init libnotify");
            return;
        }
 
        if (notification == null) {
            notification = new Notify.Notification (primary_text, secondary_text, icon_name);
        } else {
            notification.clear_hints ();
            notification.clear_actions ();
            notification.update (primary_text, secondary_text, icon_name);
        }

        try {
            beep ();
            notification.show ();
        } catch (GLib.Error err2) {
            warning ("Could not show notification: %s", err2.message);
        }
    }
}
